package hikapro.com.backpack.model;

import android.graphics.Bitmap;
import android.os.Message;

import java.util.List;

import hikapro.com.backpack.model.dao.Command;
import hikapro.com.backpack.model.dao.DAO;
import hikapro.com.backpack.model.dao.Event;
import hikapro.com.backpack.model.entities.Item;
import hikapro.com.backpack.model.entities.Set;
import hikapro.com.backpack.presenter.Presenter;

/**
 * Created by tariel on 23/04/16.
 */
public class DetailModel implements Model.Detail {

    private Presenter.ItemDetail    presenter;
    private Item                    item;
    private DAO                     dao;
    private Bitmap                  pic;

    public DetailModel() {
        this.dao = DAO.getInstance();
        dao.registerObserver(this);
    }

    // detail -->

    @Override
    public int getCount() {
        return 1;
    }
    @Override
    public Item findItem(int id) {
        return item;
    }

    @Override
    public Bitmap getPicture() {
        return pic;
    }
    // detail <--

    // events -->

    @Override
    public void notifyDataSetChanged() {
        presenter.notifyDataSetChanged();
    }
    @Override
    public void onDestroy(boolean isConfigurationChanging) {
        if ( !isConfigurationChanging ) {
            presenter = null;
        }
    }

    private void sendMessage(String message) {
        presenter.showMessage(message);
    }

    // events <--

    // process -->
    @Override
    public void executeQuery() {

        notifyDataSetChanged();
        Message command;
        command = Message.obtain();
        command.what = Command.ITEM_GET_IMAGE;
        command.arg1 = item.getId();
        dao.executeCommand(command);

    }
    // process <--


    @Override
    public void setPresenter(Presenter.ItemDetail presenter) {
        this.presenter  = presenter;
        this.item       = presenter.getCurrentItem();
    }

    @Override
    public Presenter.ItemDetail getPresenter() {
        return presenter;
    }

    @Override
    public void onEvent(Message event) {

        switch (event.what) {
            case Event.ITEM_IMAGE_LOAD_ERROR :
                break;
            case Event.ITEM_IMAGE_LOAD_COMPLETED :
                pic = (Bitmap) event.obj;
                notifyDataSetChanged();
                break;
        }

    }
}
